import ac
import euclid

import helicar
import heliSettings

class HeliSession(object):
    """A session like a qualifing or race; basically the instance of this app"""
    
    player = None
    cars = {}
    nearcars = []

    def __init__(self):
        self.player = helicar.HeliCar(0, ac.getDriverName(0))

    def updateCurrentPlayers(self, idsAndNames):
        anythingChanged = False
        for client_id in idsAndNames:
            if client_id > 0:
                if self.cars.get(client_id) is None:
                    # No player for client_id? Then create a new one
                    self.cars[client_id] = helicar.HeliCar(client_id, idsAndNames[client_id])
                    anythingChanged = True
                elif self.cars[client_id].name != idsAndNames[client_id]:
                    # Id is known, but there is a other name in it? then replace by a new one
                    self.cars[client_id] = helicar.HeliCar(client_id, idsAndNames[client_id])
                    anythingChanged = True
                #else: everything's fine, until one leaves - we will do that later. Maybe. in cutters, we didn't at all :-/

        return anythingChanged

    def calcWorldPositions(self, delta):
        #we need to do all the calculations needed to draw this effectivly.
        
        self.nearcars = []
        self.player.calcPlayer()
        playerVectorReversed =  euclid.Vector2(self.player.currentVelocityVector.x * -1, self.player.currentVelocityVector.y * -1)
        self.player.calcDrawingInformation(playerVectorReversed)

        for car in self.cars.values():
            car.calc(self.player)
            if car.currentSpeed > 0 and car.playerDistance < heliSettings.distanceThreshold:
                car.calcDrawingInformation(playerVectorReversed)
                car.calcAngleToPlayer(self.player.centerPositionGui)
                self.nearcars.append(car)
                #ac.log("helicorsa::near car {0}: {1}, local {2}, gui {3}".format(car.name, car.currentWorldPosition, car.relativePositionMeters, car.centerPositionGui))
